aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorGravatar Peter Korsgaard <jacmet@sunsite.dk>2008-03-31 19:50:05 +0000
committerGravatar Peter Korsgaard <jacmet@sunsite.dk>2008-03-31 19:50:05 +0000
commitbd6561e7813f8d080492bdd7f4c77d306387c918 (patch)
tree5b73199b27c3baf0a0cb3c586268d096385179d5
parent1b6ffcb7edd3b308bd4b212b7ad3beebe9dc0df6 (diff)
downloadbuildroot-bd6561e7813f8d080492bdd7f4c77d306387c918.tar.gz
buildroot-bd6561e7813f8d080492bdd7f4c77d306387c918.tar.bz2
buildroot: add /etc/br-version with version info to target dir
-rw-r--r--project/project.mk14
-rwxr-xr-xscripts/setlocalversion63
2 files changed, 72 insertions, 5 deletions
diff --git a/project/project.mk b/project/project.mk
index 79a03ab9db..c2d478b10f 100644
--- a/project/project.mk
+++ b/project/project.mk
@@ -3,17 +3,21 @@ PROJECT_FILE:=$(LOCAL)/$(PROJECT)/$(PROJECT).config
.PHONY: target-host-info saveconfig getconfig
-target-host-info: $(TARGET_DIR)/etc/issue $(TARGET_DIR)/etc/hostname
+target-host-info: $(TARGET_DIR)/etc/issue $(TARGET_DIR)/etc/hostname $(TARGET_DIR)/etc/br-version
$(TARGET_DIR)/etc/issue: .config
mkdir -p $(TARGET_DIR)/etc
- echo "" > $(TARGET_DIR)/etc/issue
- echo "" >> $(TARGET_DIR)/etc/issue
- echo "$(BANNER)" >> $(TARGET_DIR)/etc/issue
+ echo "" > $@
+ echo "" >> $@
+ echo "$(BANNER)" >> $@
$(TARGET_DIR)/etc/hostname: .config
mkdir -p $(TARGET_DIR)/etc
- echo "$(TARGET_HOSTNAME)" > $(TARGET_DIR)/etc/hostname
+ echo "$(TARGET_HOSTNAME)" > $@
+
+$(TARGET_DIR)/etc/br-version: .config
+ mkdir -p $(TARGET_DIR)/etc
+ echo $(BR2_VERSION)$(shell $(TOPDIR)/scripts/setlocalversion) >$@
saveconfig: $(CONFIG)/conf
mkdir -p $(LOCAL)/$(PROJECT)
diff --git a/scripts/setlocalversion b/scripts/setlocalversion
new file mode 100755
index 0000000000..1c1bdaf734
--- /dev/null
+++ b/scripts/setlocalversion
@@ -0,0 +1,63 @@
+#!/bin/sh
+# Print additional version information for non-release trees.
+
+usage() {
+ echo "Usage: $0 [srctree]" >&2
+ exit 1
+}
+
+cd "${1:-.}" || usage
+
+# Check for git and a git repo.
+if head=`git rev-parse --verify HEAD 2>/dev/null`; then
+ # Do we have an untagged version?
+ if git name-rev --tags HEAD | grep -E '^HEAD[[:space:]]+(.*~[0-9]*|undefined)$' > /dev/null; then
+ git describe | awk -F- '{printf("-%05d-%s", $(NF-1),$(NF))}'
+ fi
+
+ # Are there uncommitted changes?
+ git update-index --refresh --unmerged > /dev/null
+ if git diff-index --name-only HEAD | grep -v "^scripts/package" \
+ | read dummy; then
+ printf '%s' -dirty
+ fi
+
+ # All done with git
+ exit
+fi
+
+# Check for mercurial and a mercurial repo.
+if hgid=`hg id 2>/dev/null`; then
+ tag=`printf '%s' "$hgid" | cut -d' ' -f2`
+
+ # Do we have an untagged version?
+ if [ -z "$tag" -o "$tag" = tip ]; then
+ id=`printf '%s' "$hgid" | sed 's/[+ ].*//'`
+ printf '%s%s' -hg "$id"
+ fi
+
+ # Are there uncommitted changes?
+ # These are represented by + after the changeset id.
+ case "$hgid" in
+ *+|*+\ *) printf '%s' -dirty ;;
+ esac
+
+ # All done with mercurial
+ exit
+fi
+
+# Check for svn and a svn repo.
+if rev=`svn info 2>/dev/null | grep '^Revision'`; then
+ rev=`echo $rev | awk '{print $NF}'`
+ changes=`svn status 2>/dev/null | grep '^[AMD]' | wc -l`
+
+ # Are there uncommitted changes?
+ if [ $changes != 0 ]; then
+ printf -- '-svn%s%s%s' "$rev" -dirty "$changes"
+ else
+ printf -- '-svn%s' "$rev"
+ fi
+
+ # All done with svn
+ exit
+fi